#region usings 
using System;
using System.Net;
using System.Text;
using System.Collections.Generic;
using VVVV.PluginInterfaces.V2;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "ReadPhotos", Category = "Facebook", Help = "List albums´s photos", Author = "tgd")]
	#endregion PluginInfo
	public class FacebookReadPhotosNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Read", IsBang=true, IsSingle=true)]
        ISpread<bool> FBang;
		 
		[Input("AlbumID", IsSingle=true)]
		ISpread<string> FUserId;
		
		[Input("Access Token", IsSingle=true)]
		ISpread<string> FAccessToken;
		
		[Output("Photo Count")]
		ISpread<int> FPhotocount;
		
		[Output("IDs")]
		ISpread<string> FAlbumID;
		
		[Output("Names")]
		ISpread<string> FName;
				
		[Output("Created")]
		ISpread<string> FCreated;
		
		[Output("HTTP Links")]
		ISpread<string> FLink;
		
		#endregion fields & pins

		 
		//call to facebook
		public void Evaluate(int SpreadMax)
		{
			if (FBang[0]) 
			try {
	
		string theURI = ("https://graph.facebook.com/" + FUserId[0] + "/photos/?access_token=" + FAccessToken[0] + "&limit=200");
		
		WebClient myWebClient = new WebClient();
		myWebClient.DownloadDataCompleted += new DownloadDataCompletedEventHandler(Complete);
		myWebClient.DownloadDataAsync(new Uri (theURI));
				
		 		} catch (Exception error) {FName[0] = error.Message;} 
		}
		
		
		//output response from facebook
		public void Complete(object sender, DownloadDataCompletedEventArgs e)
		{            
  	        try {
 			
  	        string theResponse = Encoding.UTF8.GetString(e.Result); // response byte to string
  		    
  	        List<string> listRespDebug = new List<string>(theResponse.Split(',')); // original response (for debug)	
			List<string> listResp = new List<string>(theResponse.Split(','));  // split response to slices (new List)
			  	        	
  	        	//create output spreads// 	 
				List<string> listIDs = new List<string>(); 	
				List<string> listNames = new List<string>(); 	
  	        	List<string> listLinks = new List<string>(); 	
  	        	List<string> listCreated = new List<string>(); 	
  	        	  	        	
  	        	//format response and fill the lists//
  	        	listResp[0] = listResp[0].Remove(0,9); 
  	        	
				for (int i = 0; i < (listResp.Count); i++)	
			{
    			if(listResp[i].Contains("{\"id\""))      
   				{										       		
   					
   				listResp[i] = listResp[i].Remove(0,7); 	
				listResp[i] = listResp[i].Remove((listResp[i].Length-1),1); 
				
   				listResp[i+4] = listResp[i+4].Remove(0,8); 
   				listResp[i+4] = listResp[i+4].Remove((listResp[i+4].Length-1),1); 
   				 
   				if(listResp[i+6].Contains("https"))	
   					listResp[i+6] = listResp[i+6].Replace("https","http");
   				listResp[i+6] = listResp[i+6].Remove(0,10); 
   				listResp[i+6] = listResp[i+6].Remove((listResp[i+6].Length-1),1);	
   				listResp[i+6] = listResp[i+6].Replace("\\","");	
   				 
   				listResp[i+23] = listResp[i+23].Remove(0,16); 
   				listResp[i+23] = listResp[i+23].Remove((listResp[i+23].Length-6),6);
   				listResp[i+23] = listResp[i+23].Replace("T"," GMT "); 	
   				 
   				listIDs.Add(listResp[i]); 	
   				listNames.Add(listResp[i+4]); 
   				listLinks.Add(listResp[i+6]);
   				listCreated.Add(listResp[i+23]);
   					
   				}
			}
  	              	 	  
  	        	//output//
  	        	listIDs.Reverse();
  	        	listNames.Reverse();
  	        	listLinks.Reverse();
  	        	listCreated.Reverse();
  	        	
  	        	FAlbumID.SliceCount = listIDs.Count;
				FName.SliceCount = listIDs.Count;
				FLink.SliceCount = listIDs.Count;
				FCreated.SliceCount = listIDs.Count;
  	        	
  	        	FPhotocount[0] = listIDs.Count;
  	        	
  	        	for (int j = 0; j < (listIDs.Count); j++)  
			{
       			
				FAlbumID[j] = listIDs[j];
				FName[j] = listNames[j];
				FLink[j] = listLinks[j];
				FCreated[j] = listCreated[j];
			}			
				
  	        	
  	        	/*//////////////////////////////////////////// 
  	            for (int k = 0; k < (listRespDebug.Count); k++) 		//   debug loop,   
			    {FName.SliceCount = listRespDebug.Count;     		 //   all original slices on FName
    			FName[k] = listRespDebug[k];}	
  	        	*///////////////////////////////////////////////

  	        	  	        	
  	           } catch (Exception error) {FName[0] = error.Message;}	
		}		
		
	
		
	}
}

			
		